
;binary to octal example

        .MODEL  SMALL

;----------------------------------------------------------------

        .DATA

OctBuf  db 6 dup(?)
        db 'Q',0Dh,0Ah,24h
;end of OctBuf

;----------------------------------------------------------------

        .CODE
        ASSUME  DS:DGROUP

_main   PROC FAR

;set the DS register to DGROUP

        mov     ax,@DATA
        mov     ds,ax

;convert a value to octal string

        mov     ax,123456q          ;value to display
        mov     dx,offset OctBuf+5  ;offset of last buffer byte
        call    B2Oct

;display the string

        mov     ah,9                ;function = display string
        int     21h                 ;DOS function call

;terminate

        mov     ax,4C00h            ;function = terminate
        int     21h                 ;DO function call

_main   ENDP

;----------------------------------------------------------------

B2Oct   PROC

;16-bit binary to octal ASCII string
;written by DednDave

;Call With: AX = value to convert
;           DX = offset of last byte of 6 byte buffer

;  Returns: DX = offset of first byte of string
;           all other registers preserved

        push    ax                  ;save registers
        push    di
        xchg    ax,dx               ;val in DX, buffer in AX
        xchg    ax,di               ;buffer in DI

B2Oct0: mov     ax,dx               ;value in AX
        and     al,7                ;lower 3 bits only
        or      al,30h              ;make it ASCII numeric
        mov     [di],al             ;place it in string
        dec     di                  ;point to next buffer byte
        shr     dx,1                ;adjust for next octal
        shr     dx,1
        shr     dx,1
        jnz     B2Oct0              ;until done

        inc     di                  ;point to first byte
        mov     dx,di               ;offset in DX
        pop     ax                  ;restore registers
        pop     di
        ret                         ;exit routine

B2Oct   ENDP

;----------------------------------------------------------------

        END     _main

